# Version of Hosting Appliance software RPM
%define bindversion 8.2.3

Summary: Hosting Appliance Secure DNS Server
Name: bind
Version: %{bindversion}
Release: 142
Copyright: Under license to Seller from Intel Corporation.
Group: System Environment/Daemons
Source0: bind-%{bindversion}-src.tar.gz
Source1: bind-%{bindversion}-doc.tar.gz
Source2: bind-%{bindversion}-contrib.tar.gz
Source3: named-chroot.init
Source4: named.logrotate
Source5: utils-1.0.tar.gz
Source6: bind-chroot-8.2.2_P5-1.jail.tar.gz
Source7: intel.named.conf

Patch0: bind-8.2.2-rh.patch
Patch1: bind-8.1.2-nonlist.patch
Patch2: bind-8.1.2-fds.patch
# Patch3: bind-8.2-glibc21.patch
Patch4: bind-8.2-host.patch
Patch6: bind-chroot-8.2.2_P5-1.static.xfer.patch
Patch7: bind-chroot-8.2.2_P5-1.static.named.patch
Patch8: holelogd-linux.diff
Patch9: bind-chroot-8.2.3-intel.ndc.patch
# Patch10: bind-8.8.2p5-hostmx.patch
# Patch11: bind-8.8.2p5-ttl.patch
Patch12: bind-8.2.2_P5-restart.patch

Buildroot: /var/tmp/%{name}-root
Prereq: /sbin/chkconfig, shadow-utils, grep, sh-utils, /bin/cat, /bin/chmod, /usr/sbin/useradd, perl
Obsoletes: bind

%define jail /home/named
%define username named
%define groupname named

%description
BIND (Berkeley Internet Name Domain) is an implementation of the DNS
(Domain Name System) protocols. BIND includes a DNS server (named), 
which resolves host names to IP addresses, and a resolver library 
(routines for applications to use when interfacing with DNS).  A DNS 
server allows clients to name resources or objects and share the 
information with other network machines.  The named DNS server can be 
used on workstations as a caching name server, but is generally only 
needed on one machine for an entire network.  Note that the 
configuration files for making BIND act as a simple caching nameserver 
are now included in this package as part of the default configuration.

This version of BIND is based off ISC BIND 8.2.3, along with various patches
and modifications necessary for running BIND in a restricted "jail" directory
tree.  This allows for greater security and isolation from other processes
on the system.

The bind-chroot package runs the DNS server daemon under the non-root
user and group and in the restricted BIND "jail" directory.

%package -n bind-utils
Summary: DNS utilities:  host, dig, dnsquery, and nslookup.
Group: Applications/System

%description -n bind-utils
Bind-utils contains a collection of utilities for querying DNS (Domain
Name Service) name servers to find out information about Internet hosts.
These tools will provide you with the IP addresses for given host names,
as well as other information about registered domains and network 
addresses.

You should install bind-utils if you need to get information from DNS name
servers.

%package -n bind-devel
Summary: Include files and libraries needed for bind DNS development.
Group: Development/Libraries

%description -n bind-devel
The bind-devel package contains all the include files and the 
library required for DNS (Domain Name Service) development for 
BIND versions 8.2.3.

You should install bind-devel if you want to develop bind DNS
applications. If you install bind-devel, you'll also need to install
bind.

%prep
%setup -q -c -a 1 -a 2
%patch0 -p0
%patch1 -p0
%patch2 -p1
# Removed outdated versions of patches due to 8.2.3 upgrade.
# %patch3 -p1
%patch4 -p1
# %patch10 -p1
# %patch11 -p1
%patch12 -p1

# No longer needed
# cd src/bin/named-xfer
# %patch5 -p0
# cd ../../../

rm -f compat/include/sys/cdefs.h

# holelogd
%setup -D -T -a 5

# jail
%setup -D -T -a 6

# Patch to static link named-xfer
%patch6 -p1 -b .static
# Patch to static link named if we have libresolv
%patch7 -p1 -b .static

# Holelogd patch to use SOCK_DGRAM
%patch8 -p1 -b .stream

%build

# XXX hack around egcs -m486 bug (#3413, #3485)
%ifarch i386
RPM_OPT_FLAGS="`echo $RPM_OPT_FLAGS | sed -e 's|-m486||'`"
%endif

make -C src
make clean all -C src SUBDIRS=../doc/man

# This is _really_ not nice
patch -p1 < $RPM_SOURCE_DIR/bind-chroot-8.2.3-intel.ndc.patch
sed 's,JAILDIRECTORY,%jail,' <src/bin/ndc/pathnames.h >src/bin/ndc/pathnames.h.new
mv src/bin/ndc/pathnames.h.new src/bin/ndc/pathnames.h

# rebuild ndc
rm -f src/bin/ndc/*.o
make -C src
# end of ugly code

cp src/bin/named-xfer/named-xfer jail/usr/sbin/named-xfer

# A little tool for logging from chroot
cd utils-1.0
gcc -s ${RPM_OPT_FLAGS} -o holelogd holelogd.c
cd -

# Adjust for the jail
[ -z "%{jail}" ] || {
	sed '/^CHROOTDIR=/s%=%=%{jail}%
/^USER=/s%=%="-u %{username}"%
/^GROUP=/s%=%="-g %{groupname}"%' $RPM_SOURCE_DIR/named-chroot.init >named.init
}


%install
rm -rf $RPM_BUILD_ROOT
mkdir -p ${RPM_BUILD_ROOT}%jail
mkdir -p ${RPM_BUILD_ROOT}/usr/{bin,lib,sbin}
mkdir -p ${RPM_BUILD_ROOT}/usr/man/{man1,man3,man5,man7,man8}
mkdir -p ${RPM_BUILD_ROOT}/etc/rc.d/{init,rc0,rc1,rc2,rc3,rc4,rc5,rc6}.d

make DESTDIR=$RPM_BUILD_ROOT install -C src
make DESTDIR=$RPM_BUILD_ROOT INSTALL=install install -C src SUBDIRS=../doc/man

# This will be log daemon for our jail alone so we can easily start and
# stop it if there are others for other jails.
install -m 755 -s utils-1.0/holelogd ${RPM_BUILD_ROOT}/usr/sbin/holelogd.named

install -m 755 named.init ${RPM_BUILD_ROOT}/etc/rc.d/init.d/named
ln -sf ../init.d/named ${RPM_BUILD_ROOT}/etc/rc.d/rc0.d/K45named
ln -sf ../init.d/named ${RPM_BUILD_ROOT}/etc/rc.d/rc1.d/K45named
ln -sf ../init.d/named ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d/K45named
ln -sf ../init.d/named ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d/K45named
ln -sf ../init.d/named ${RPM_BUILD_ROOT}/etc/rc.d/rc4.d/K45named
ln -sf ../init.d/named ${RPM_BUILD_ROOT}/etc/rc.d/rc5.d/K45named
ln -sf ../init.d/named ${RPM_BUILD_ROOT}/etc/rc.d/rc6.d/K45named

ln -sf ..%jail/var/named/named.conf ${RPM_BUILD_ROOT}/etc/named.conf
( cd jail && tar cf - . ) | ( cd $RPM_BUILD_ROOT%jail && tar xvf - )

mkdir -p ${RPM_BUILD_ROOT}/etc/logrotate.d
install -m644 %SOURCE4 $RPM_BUILD_ROOT/etc/logrotate.d/named

# gather holelogd docs
rm -rf holelogd
mkdir -p holelogd
chmod 0755 holelogd
cp -a utils-1.0/LICENSE utils-1.0/README holelogd

cp -f $RPM_SOURCE_DIR/intel.named.conf ${RPM_BUILD_ROOT}%jail/var/named/named.conf

#strip things
strip $RPM_BUILD_ROOT/usr/bin/* || :
strip $RPM_BUILD_ROOT/usr/sbin/* || :
strip $RPM_BUILD_ROOT%jail/usr/sbin/* || :

%pre
if grep -q ^%groupname: /etc/group
then :
else
	echo "Adding group %groupname to the system." >&2
	/usr/sbin/groupadd -r %groupname
fi
if grep -q ^%username: /etc/passwd
then :
else
	echo "Adding user %username to the system." >&2
	/usr/sbin/useradd -M -c 'Domain name server' -d %jail -g %groupname -s /sbin/nologin -r %username
fi
	
%post
/sbin/chkconfig --add named
rm -f %{jail}/dev/null
mknod -m a+rw %{jail}/dev/null c 1 3

# some systems seem to want /etc/group, others don't care
grep ^%{groupname}: /etc/group >%{jail}/etc/group
cp /etc/localtime %{jail}/etc/localtime

%preun
if [ $1 = 0 ]; then
   /sbin/chkconfig --del named
   /etc/rc.d/init.d/named stop
fi

rm -rf ${RPM_BUILD_ROOT}

%files
%defattr(-,root,root)
%doc src/README src/INSTALL src/Version src/CHANGES 
%doc src/TODO src/bin/named-bootconf
%doc doc/bog doc/html doc/misc doc/notes doc/rfc doc/tmac
%doc holelogd

/etc/named.conf
%config /etc/logrotate.d/named
%config /etc/rc.d/init.d/named
%config(missingok) /etc/rc.d/rc0.d/K45named
%config(missingok) /etc/rc.d/rc1.d/K45named
%config(missingok) /etc/rc.d/rc2.d/K45named
%config(missingok) /etc/rc.d/rc3.d/K45named
%config(missingok) /etc/rc.d/rc4.d/K45named
%config(missingok) /etc/rc.d/rc5.d/K45named
%config(missingok) /etc/rc.d/rc6.d/K45named

%dir %{jail}
%dir %{jail}/dev
%verify() %{jail}/dev/log
%verify(mode) %{jail}/dev/null
%dir %{jail}/etc
%{jail}/etc/named.conf
%verify(not md5 size mtime) %{jail}/etc/group
%verify(not md5 size mtime) %{jail}/etc/localtime
%{jail}/usr
%dir %{jail}/var
%dir %{jail}/var/named
%dir %{jail}/var/named/master
%config %{jail}/var/named/named.conf
%config %{jail}/var/named/named.root
%{jail}/var/named/named.conf.pony
%config %{jail}/var/named/master/127.0.0
%config %{jail}/var/named/master/localhost
%config %{jail}/var/named/master/bind
%attr(- %{username} %{groupname}) %{jail}/var/named/slave
%attr(- %{username} %{groupname}) %{jail}/var/run
%attr(- %{username} %{groupname}) %{jail}/var/tmp

/usr/sbin/dnskeygen
/usr/sbin/irpd
/usr/sbin/named
/usr/sbin/named-bootconf
/usr/sbin/named-xfer
/usr/sbin/ndc
/usr/sbin/holelogd.named

/usr/man/man1/dnskeygen.1
/usr/man/man5/named.conf.5
/usr/man/man7/hostname.7
/usr/man/man8/named.8
/usr/man/man8/ndc.8
/usr/man/man8/named-bootconf.8
/usr/man/man8/named-xfer.8
     
%files -n bind-utils
%defattr(-,root,root)
/usr/bin/addr
/usr/bin/dig
/usr/bin/dnsquery
/usr/bin/host
/usr/bin/mkservdb
/usr/bin/nslookup
/usr/bin/nsupdate
/usr/lib/nslookup.help
/usr/man/man1/dig.1
/usr/man/man1/dnsquery.1
/usr/man/man1/host.1
/usr/man/man5/irs.conf.5
/usr/man/man5/resolver.5
/usr/man/man8/nslookup.8
/usr/man/man8/nsupdate.8

%files -n bind-devel
%defattr(-,root,root)
/usr/lib/bind
/usr/man/man3/getaddrinfo.3
#/usr/man/man3/getnetent.3
/usr/man/man3/hesiod.3
/usr/man/man3/inet_cidr.3
#/usr/man/man3/resolver.3
/usr/man/man3/tsig.3

%changelog
* Fri Jan  7 2000 Jan "Yenya" Kasprzak <kas@fi.muni.cz>
- modified the official RedHat package to the chrooted environment
  (using pieces of John A. Martin <jam@jamux.com>'s bind-chroot-8.1.2
  source RPM).
- update to 8.2.2-P5

* Wed Nov 10 1999 Bill Nottingham <notting@redhat.com>
- update to 8.2.2-P3

* Tue Oct 12 1999 Cristian Gafton <gafton@redhat.com>
- add patch to stop a cache only server from complaining about lame servers
  on every request.

* Fri Sep 24 1999 Preston Brown <pbrown@redhat.com>
- use real stop and start in named.init for restart, not ndc restart, it has
  problems when named has changed during a package update... (# 4890)

* Fri Sep 10 1999 Bill Nottingham <notting@redhat.com>
- chkconfig --del in %preun, not %postun

* Mon Aug 16 1999 Bill Nottingham <notting@redhat.com>
- initscript munging

* Mon Jul 26 1999 Bill Nottingham <notting@redhat.com>
- fix installed chkconfig links to match init file

* Sat Jul  3 1999 Jeff Johnson <jbj@redhat.com>
- conflict with new (in man-1.24) man pages (#3876,#3877).

* Tue Jun 29 1999 Bill Nottingham <notting@redhat.com>
- fix named.logrotate (wrong %SOURCE)

* Fri Jun 25 1999 Jeff Johnson <jbj@redhat.com>
- update to 8.2.1.
- add named.logrotate (#3571).
- hack around egcs-1.1.2 -m486 bug (#3413, #3485).
- vet file list.

* Fri Jun 18 1999 Bill Nottingham <notting@redhat.com>
- don't run by default

* Sun May 30 1999 Jeff Johnson <jbj@redhat.com>
- nslookup fixes (#2463).
- missing files (#3152).

* Sat May  1 1999 Stepan Kasal <kasal@math.cas.cz>
- nslookup patched:
  to count numRecords properly
  to fix subsequent calls to ls -d
  to parse "view" and "finger" commands properly
  the view hack updated for bind-8 (using sed)

* Wed Mar 31 1999 Bill Nottingham <notting@redhat.com>
- add ISC patch
- add quick hack to make host not crash
- add more docs

* Fri Mar 26 1999 Cristian Gafton <gafton@redhat.com>
- add probing information in the init file to keep linuxconf happy
- dont strip libbind

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 3)

* Wed Mar 17 1999 Preston Brown <pbrown@redhat.com>
- removed 'done' output at named shutdown.

* Tue Mar 16 1999 Cristian Gafton <gafton@redhat.com>
- version 8.2

* Wed Dec 30 1998 Cristian Gafton <gafton@redhat.com>
- patch to use the __FDS_BITS macro
- build for glibc 2.1

* Wed Sep 23 1998 Jeff Johnson <jbj@redhat.com>
- change named.restart to /usr/sbin/ndc restart

* Sat Sep 19 1998 Jeff Johnson <jbj@redhat.com>
- install man pages correctly.
- change K10named to K45named.

* Wed Aug 12 1998 Jeff Johnson <jbj@redhat.com>
- don't start if /etc/named.conf doesn't exist.

* Sat Aug  8 1998 Jeff Johnson <jbj@redhat.com>
- autmagically create /etc/named.conf from /etc/named.boot in %post
- remove echo in %post

* Wed Jun 10 1998 Jeff Johnson <jbj@redhat.com>
- merge in 5.1 mods

* Sun Apr 12 1998 Manuel J. Galan <manolow@step.es>
- Several essential modifications to build and install correctly.
- Modified 'ndc' to avoid deprecated use of '-'

* Mon Dec 22 1997 Scott Lampert <fortunato@heavymetal.org>
- Used buildroot
- patched bin/named/ns_udp.c to use <libelf/nlist.h> for include
  on Redhat 5.0 instead of <nlist.h>

